/*---------------------------------------------------------------------------*/
/*                      INGENIOUS TECHNOLOGY CO., LTD.                       */
/*                                                                           */
/*                   MOUSE.H    For Mouse Function Call Include              */
/*                   Support For C                                           */
/*                                                                           */
/*      Written on 10/01/92 by Dannes Hsieh                                  */
/*---------------------------------------------------------------------------*/

#if !defined(__MOUSE__)
#define __MOUSE__    1

#define   LEFT_B     1
#define   RIGHT_B    2
#define   MIDDLE_B   4

char Reset(void);
char Get_Button_Num(void);
void Show_Mouse(void);
void Hide_Mouse(void);
char Left_Pressed(void);
char Right_Pressed(void);
char Mid_Pressed(void);
char Button_Pressed(char);
void Get_XY(int *, int *);
void Get_T_XY(int *, int *);
void Set_XY(int, int);
void Set_T_XY(int, int);
int  Pressed_Status(int, int *, int *, int *);
int  Released_Status(int, int *, int *, int *);
void Set_X_Range(int, int);
void Set_Y_Range(int, int);
void Set_Graphic_Cursor(int, int, unsigned int far *);
void Set_Text_Cursor(int, int, int);
int  Motion(int *, int *);
void Event_Set(unsigned int, void far *);
void Lightpen_Emu_On(void);
void Lightpen_Emu_Off(void);
void Set_M2P_Ratio(int, int);
void Block_Of_Hide(int, int, int, int);
void Double_Speed(int);
void far *Swap_Event_Set(unsigned int *, void far *);
int Get_Storage_Req();
void Save_Mouse_State(void *);
void Restore_Mouse_State(void *);


unsigned Cursor[4][32]= {
   {
   /*  Cursor[0] ----->  Hand  */
   /*  Screen Mask  */
     0xE1FF,      /*  1110000111111111   */
     0xE1FF,      /*  1110000111111111   */
     0xE1FF,      /*  1110000111111111   */
     0xE1FF,      /*  1110000111111111   */
     0xE1FF,      /*  1110000111111111   */
     0xE000,      /*  1110000000000000   */
     0xE000,      /*  1110000000000000   */
     0xE000,      /*  1110000000000000   */
     0x0000,      /*  0000000000000000   */
     0x0000,      /*  0000000000000000   */
     0x0000,      /*  0000000000000000   */
     0x0000,      /*  0000000000000000   */
     0x0000,      /*  0000000000000000   */
     0x0000,      /*  0000000000000000   */
     0x0000,      /*  0000000000000000   */
     0x0000,      /*  0000000000000000   */

   /*  Cursor Mask  */
     0x1E00,      /*  0001111000000000   */
     0x1200,      /*  0001001000000000   */
     0x1200,      /*  0001001000000000   */
     0x1200,      /*  0001001000000000   */
     0x1200,      /*  0001001000000000   */
     0x13FF,      /*  0001001111111111   */
     0x1249,      /*  0001001001001001   */
     0x1249,      /*  0001001001001001   */
     0xF249,      /*  1111001001001001   */
     0x9001,      /*  1001000000000001   */
     0x9001,      /*  1001000000000001   */
     0x9001,      /*  1001000000000001   */
     0x8001,      /*  1000000000000001   */
     0x8001,      /*  1000000000000001   */
     0x8001,      /*  1000000000000001   */
     0xFFFF       /*  1111111111111111   */
   },

   {
   /*  Cursor[1] -----> Arrow  */
   /*  Screen Mask  */
     0x3FFF,      /*  0011111111111111   */
     0x1FFF,      /*  0001111111111111   */
     0x0FFF,      /*  0000111111111111   */
     0x07FF,      /*  0000011111111111   */
     0x03FF,      /*  0000001111111111   */
     0x01FF,      /*  0000000111111111   */
     0x00FF,      /*  0000000011111111   */
     0x007F,      /*  0000000001111111   */
     0x003F,      /*  0000000000111111   */
     0x001F,      /*  0000000000011111   */
     0x01FF,      /*  0000000111111111   */
     0x10FF,      /*  0001000011111111   */
     0x30FF,      /*  0011000011111111   */
     0xF87F,      /*  1111100001111111   */
     0xF87F,      /*  1111100001111111   */
     0xFC3F,      /*  1111110000111111   */

   /*  Cursor Mask  */
     0x0000,      /*  0000000000000000   */
     0x4000,      /*  0100000000000000   */
     0x6000,      /*  0110000000000000   */
     0x7000,      /*  0111000000000000   */
     0x7800,      /*  0111100000000000   */
     0x7C00,      /*  0111110000000000   */
     0x7E00,      /*  0111111000000000   */
     0x7F00,      /*  0111111100000000   */
     0x7F80,      /*  0111111110000000   */
     0x7FC0,      /*  0111111111000000   */
     0x6C00,      /*  0110110000000000   */
     0x4600,      /*  0100011000000000   */
     0x0600,      /*  0000011000000000   */
     0x0300,      /*  0000001100000000   */
     0x0300,      /*  0000001100000000   */
     0x0180       /*  0000000110000000   */
   },

   {
   /*  Cursor[2] -----> Inverse Arrow  */
   /*  Screen Mask  */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */

   /*  Cursor Mask  */
     0x0000,      /*  0000000000000000   */
     0x4000,      /*  0100000000000000   */
     0x6000,      /*  0110000000000000   */
     0x7000,      /*  0111000000000000   */
     0x7800,      /*  0111100000000000   */
     0x7C00,      /*  0111110000000000   */
     0x7E00,      /*  0111111000000000   */
     0x7F00,      /*  0111111100000000   */
     0x7F80,      /*  0111111110000000   */
     0x7FC0,      /*  0111111111000000   */
     0x6C00,      /*  0110110000000000   */
     0x4600,      /*  0100011000000000   */
     0x0600,      /*  0000011000000000   */
     0x0300,      /*  0000001100000000   */
     0x0300,      /*  0000001100000000   */
     0x0180       /*  0000000110000000   */
   },

   {
   /*  Cursor[3] -----> Cross  */
   /*  Screen Mask  */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */
     0xFFFF,      /*  1111111111111111   */

   /*  Cursor Mask  */
     0x0200,      /*  0000001000000000   */
     0x0200,      /*  0000001000000000   */
     0x0200,      /*  0000001000000000   */
     0x0200,      /*  0000001000000000   */
     0x0200,      /*  0000001000000000   */
     0x0000,      /*  0000000000000000   */
     0xF8F8,      /*  1111100011111000   */
     0x0000,      /*  0000000000000000   */
     0x0200,      /*  0000001000000000   */
     0x0200,      /*  0000001000000000   */
     0x0200,      /*  0000001000000000   */
     0x0200,      /*  0000001000000000   */
     0x0200,      /*  0000001000000000   */
     0x0000,      /*  0000000000000000   */
     0x0000,      /*  0000000000000000   */
     0x0000       /*  0000000000000000   */
   }
 };


#endif
